<?
// 2024.09.09 에 func.php , session.php 파일이 연관되어 패치됨
//--------------------------------------------------------------------------------
// 인잭션공경 방어
//--------------------------------------------------------------------------------
if (!function_exists("sql_clear")){
	function sql_clear($cval){ 
		global $g_sqlclear_array;
		if(!is_array($cval)){
			for($i=0;$i <= count($g_sqlclear_array);$i++){
				if(strpos($cval,$g_sqlclear_array[$i])!==false){
					error_msg("사용하시면 안되는 특수문자또는 단어가 포함되어 있습니다.");
					exit;
				}
			}
		}
		return $cval;
	} 
}

// ----------------------------------------------------------
// url인코딩 된 상태이면 디코딩시키기
// ----------------------------------------------------------
if (!function_exists("is_url_encoded")){
	function is_url_encoded($string) {	
		if (urldecode($string) !== $string) {
			return urldecode($string);
		}else{
			return $string;
		}
	}
}

// ----------------------------------------------------------
// 시스템파일인지 아닌지 (삭제나 다운로드 보안패치용)
// ----------------------------------------------------------
if (!function_exists("not_program_file")){
	function not_program_file($file_name){
		$not_file_all = array("php","html","css","js");
		$file_ex = substr(strrchr($file_name,"."),1);
		$file_ex = strtolower($file_ex); //소문자변환

		if(in_array($file_ex,$not_file_all)){
			return;
		}

		return $file_name;
	}
}

// ----------------------------------------------------------
// (숫자)(,)(.)만 허용 - 보안패치용
// ----------------------------------------------------------
if (!function_exists("is_safe_para1")){
	function is_safe_para1($v){
		if (preg_match('/^[0-9,.]+$/', $v)) {
			return $v;
		}else if(trim($v)){
			echo"승인되지 않은 특수문자 사용으로 차단되었습니다.1";
			exit;
		}
	}
}

// ----------------------------------------------------------
// (영문)(숫자)(,)(.)(_)(-) 만 허용 - 보안패치용
// ----------------------------------------------------------
if (!function_exists("is_safe_para2")){
	function is_safe_para2($v){
		if (preg_match('/^[A-Za-z0-9,._\-]+$/', $v)) {
			return $v;
		}else if(trim($v)){
			echo"승인되지 않은 특수문자 사용으로 차단되었습니다.2";
			exit;
		}
	}
}

// ----------------------------------------------------------
// (영문)(한글)(숫자)(,)(.)(+)(_)(-)  만 허용 - 보안패치용
// ----------------------------------------------------------
if (!function_exists("is_safe_para3")){
	function is_safe_para3($v){

		global $db_charset;

		if (preg_match('/^[A-Za-z0-9가-힣\xA1-\xFE\xA1-\xFE, ._\+\-]+$/',$v)) {			
			return addslashes(stripslashes($v));
		}else if(trim($v)){
			echo"승인되지 않은 특수문자 사용으로 차단되었습니다.3";
			exit;
		}
	}
}

// ----------------------------------------------------------
// (영문)(한글)(숫자)(,)(.)(+)(_)(-)(')(띄워쓰기)(/)(:)(%)(=) 만 허용 - 보안패치용
// ----------------------------------------------------------
if (!function_exists("is_safe_para4")){
	function is_safe_para4($v){
		global $db_charset;

		//인젝션공격단어
		$sql_injection_str = array("select","limit","drop","union","insert","--", ";", "/*", "*/", "'", "\"","=","|");

		$match_count = 0; // 일치하는 키워드 수 카운트
		$injection_text = "";
		$value_lower = strtolower($v);

		// SQL 인젝션 키워드가 포함되어 있는지 검사
		foreach ($sql_injection_str as $injection) {
			if (stripos($value_lower, $injection) !== false) {
				$match_count++;
				$injection_text .= $injection." ";
			}
		}

		// 3개 이상의 인젝션 키워드가 발견된 경우
		if ($match_count >= 3) {
			//echo" <script>alert('SQL 인젝션 공격이 감지되었습니다. 전송값:".htmlspecialchars($v))." 차단값 ($injection_text))</script>";
			echo" <script>alert('SQL 인젝션 공격이 감지되어서 차단합니다.')</script>";
			exit;
		}

		return $v;

		/*
		if (preg_match('/^[A-Za-z0-9가-힣\xA1-\xFE\xA1-\xFE, ._\+\'\/\-\:\@\%\=\?\(\)]+$/',$v)) {		
			return addslashes(stripslashes($v));
		}else if(trim($v)){
			echo"승인되지 않은 특수문자 사용으로 차단되었습니다.4";
			exit;
		}*/

	}
}


// ----------------------------------------------------------
// GET 파라미터 보안처리
// ----------------------------------------------------------
foreach ($_GET as $key => $value) {
	if($g_page_name != "m_cart.php"){
		if($key != "r_path" && $key !="ps_search2" && $key !="ps_search" && $key !="ps_brand" && $key != "url" && $key != "returnUrl" && $key != "Ret_URL" && $key != "ps_r_company"){
				$_GET[$key] = is_safe_para4($value);
		}
	}
}


// ----------------------------------------------------------
// POST 전송값 스크립트차단
// ----------------------------------------------------------
foreach ($_POST as $key => $value) {
	
	if($g_check_rank < 7){
		if($g_page_name == "m_board_ok.php" || $g_page_name == "m_mall_detail_ok.php"){
			
			// htmlspecialchars 을 사용하고 싶지만.. 에디터기능 때문에.. 그리고 게시판 제목같은 곳에서 html 사용하는 고객이 간혹있어서..
			$_POST = array_map('avoid_crack', $_POST); 
			
		}else if($g_page_name == "m_member_ok.php" || $g_page_name == "m_memo_ok.php" || $g_page_name == "m_userinfo_ok.php" || $g_page_name == "m_etc_ok.php" || $g_page_name == "m_poll_ok.php" || $g_page_name == "ok.php"){
			
			$_POST = array_map('avoid_crack', $_POST); 

			if($db_charset == "utf8"){
				$_POST[$key] = htmlspecialchars($value, ENT_QUOTES, 'UTF-8');
			}else{
				$_POST[$key] = htmlspecialchars($value, ENT_QUOTES, 'EUC-KR');
			}
		}
	}
}


// ----------------------------------------------------------
// register_globals_on일때
// ----------------------------------------------------------
$params = array_merge($_POST, $_GET, $_COOKIE,$_SESSION); 
foreach($params as $key => $value) { 
	global ${$key}; 
	${$key} = $value; 
} 


// ----------------------------------------------------------
// 주요파라미터 보안수위 조절
// ----------------------------------------------------------
if($g_page_name != "bankauto.php"){
	$no				= is_safe_para1($no);
	$ps_uid			= is_safe_para1($ps_uid);
	$ps_boid		= is_safe_para1($ps_boid);
	$ps_ctid		= is_safe_para1($ps_ctid);
	$ps_goid		= is_safe_para1($ps_goid);
	$ps_cuid		= is_safe_para1($ps_cuid);
	$uid			= is_safe_para1($uid);
	$goods_id		= is_safe_para1($goods_id);
	$category_num	= is_safe_para1($category_num);	
	$year			= is_safe_para1($year);	
	$mon			= is_safe_para1($mon);	
	$ps_good_status	= is_safe_para1($ps_good_status);

	$ps_sess		= is_safe_para2($ps_sess);
	$ps_db			= is_safe_para2($ps_db);
	$ps_mode		= is_safe_para2($ps_mode);
	$_GET['partner_id'] = is_safe_para2($_GET['partner_id']);
	$partner_id		= is_safe_para2($partner_id);
	$ps_pname		= is_safe_para2($ps_pname);
	$ps_page		= is_safe_para2($ps_page);
	$chk_id			= is_safe_para2($chk_id);
	$ps_out			= is_safe_para2($ps_out);	

	$ps_search		= is_safe_para4($ps_search);
	$ps_search2		= is_safe_para4($ps_search2);
	$ps_brand		= is_safe_para4($ps_brand);
}
?>